<?php
/*

Modified by CMSimple-Styles.com

ALSO: a content sensitive subcontent function for CMSimple.

INTRODUCTION: 
This function is meant to be placed in the template file.
When the user is visiting a certain page in the content the 
function detects which page is beign displayed and displays
additional content based on a plain html file (to be used 
in side panels or top areas for instance).

USAGE:
just add the code: <?PHP echo also('subcontentfilename');?>
to your template (where you want the subcontent to appear).

'subcontentfilename' may be any html file (without extension)
inside the plugin folder.

Remember to place this call inside a DIV or Table-cell so you
can control it's appearance or size through CSS.

You can add this function many times in your template, and they can
point to different subcontent files) just change the 'subcontentfilename'
option in the function call. You don't even need to create the html file,
the function will do it for you.

Adding new subcontent to your subcontent areas is as simple as login in
as administrator, browsing to the relevant content page, pasting your
html subcontents inside the subcontent textarea and pressing save. READY.

There are no config files or options yet. They are soon to come though.

ENJOY!

cmsimple-styles.com ~ Changed usage of current url to usage of current content header because of "umlaute"
and removed trailing blanks in TEXTAREA
    
cmsimple-styles.com - Strip slashes added.    
*/

function also_readfile($contentfile) {
    global $pth;
    $file = $contentfile.'.htm';
    $filename = $pth['folder']['plugins'].'also/'.$file;
    if (!$handle = fopen($filename, 'r')) {$error = 'Cannot open file ('.$filename.')';    return $error;}
    $filecontents = fread($handle, filesize($filename));
    fclose($handle);
    return $filecontents;
    }

function also_readcontents($subcontent) {
    $count = 0; 
    $tagend = false;
     while ($i <=strlen($subcontent)) {
        if (substr($subcontent, $i, 1)=='<') {
            $j = $i;
            while ($j <=strlen($subcontent)) {if (substr($subcontent, $j, 1)=='>') break; $j++;}
            if ($j > $i) {
                if (substr_count(strtolower(substr($subcontent,$i,$j-$i)),'h1')>0) {
                    if ($tagend==false) {$also[$count]['tagini']=$i; $othertag[$count]['tagini']=$j; $tagend=true;}
                    else {$also[$count]['tagend']=$j; $othertag[$count]['tagend']=$i; $count++; $tagend=false;}
                    }
                if (substr_count(strtolower(substr($subcontent,$i,$j-$i)),'h2')>0) {
                    if ($tagend==false) {$also[$count]['tagini']=$i; $othertag[$count]['tagini']=$j; $tagend=true;}
                    else {$also[$count]['tagend']=$j; $othertag[$count]['tagend']=$i; $count++; $tagend=false;}
                    }
                if (substr_count(strtolower(substr($subcontent,$i,$j-$i)),'h3')>0) {
                    if ($tagend==false) {$also[$count]['tagini']=$i; $othertag[$count]['tagini']=$j; $tagend=true;}
                    else {$also[$count]['tagend']=$j; $othertag[$count]['tagend']=$i; $count++; $tagend=false;}
                    }
                }
            $i = $j;
            }
        $i++;
        }
    $i = $also[$count-1]['tagend'];
    while ($i <=strlen($subcontent)) {
        $i++;
        if (substr($subcontent, $i, 1)=='<') {
            $j = $i;
            while ($j <=strlen($subcontent)) {if (substr($subcontent, $j, 1)=='>') break; $j++;}
            if (substr_count(strtolower(substr($subcontent,$i,$j-$i)),'/body')>0) {$also[$count]['tagini']=$i;}
            $i = $j;
            }
        }
    $also['last'] = $count-1;
    for ($i = 0; $i<=$also['last']; $i++){
        $also[$i]['content'] = substr($subcontent, $also[$i]['tagend']+1, $also[$i+1]['tagini']-$also[$i]['tagend']-1);
        //WB- $also[$i]['h'] = str_replace(' ', '_', substr($subcontent, $othertag[$i]['tagini']+1, $othertag[$i]['tagend']-$othertag[$i]['tagini']-1));
        $also[$i]['h'] = substr($subcontent, $othertag[$i]['tagini']+1, $othertag[$i]['tagend']-$othertag[$i]['tagini']-1);

    }
    unset($also[$count]);
    return $also;
    }

function also_savecontents($also) {
    global $pth, $h;
    
    if ($also['last']>1) {
        $file = $also['name'].'.htm';
        $filename = $pth['folder']['plugins'].'also/'.$file;
        if (!$handle = fopen($filename, 'r')) {$error = 'Cannot open file ('.$filename.')';    return $error;}
        $filecontents = fread($handle, filesize($filename));
        fclose($handle);
        $file = $also['name'].'-backup.htm';
        $filename = $pth['folder']['plugins'].'also/'.$file;
        if (!$handle = fopen($filename, 'w')) {$error = 'Cannot open file ('.$filename.')';    return $error;}
        if (fwrite($handle, $filecontents) === FALSE) {$error = 'Cannot write to file ('.$filename.')'; return $error;}
        fclose($handle);
        }
    $filecontents = '<HTML><BODY>'.chr(10);
    foreach ($h as $head) {
        for ($i = 0; $i<=$also['last']; $i++) {
    //        if (strtolower($head)==str_replace('_', ' ', strtolower($also[$i]['h']))) {
             if (strtolower($head)==strtolower($also[$i]['h'])) {
                for ($j = 0; $j<= strlen($also[$i]['content']); $j++) { if(substr($also[$i]['content'],$j,1)!=' ' & substr($also[$i]['content'],$j,1)!=chr(10) & substr($also[$i]['content'],$j,1)!=chr(13)) break;}
                for ($k = strlen($also[$i]['content']); $k>=$j; $k--) { if(substr($also[$i]['content'],$k,1)!=' ' & substr($also[$i]['content'],$k-1,1)!=chr(10) & substr($also[$i]['content'],$k-1,1)!=chr(13)) break;}
                $prueba = substr($also[$i]['content'],$j,$k-$j);
                if ($prueba =='') continue;
                //$filecontents .= '<H1>'.str_replace('_', ' ',$also[$i]['h']).'</H1>'.chr(10);
                $filecontents .= '<H1>'.$also[$i]['h'].'</H1>'.chr(10);
 
                $filecontents .= substr($also[$i]['content'],$j,$k-$j).chr(10);
                break;
                }
            }
        }
    $filecontents .= '</BODY></HTML>';
    $file = $also['name'].'.htm';
    $filename = $pth['folder']['plugins'].'also/'.$file;
    if (!$handle = fopen($filename, 'w')) {$error = 'Cannot open file ('.$filename.')';    return $error;}
    if (fwrite($handle, $filecontents) === FALSE) {$error = 'Cannot write to file ('.$filename.')'; return $error;}
    fclose($handle);
    return;
    }

function also_vhtml($value){
 
    $valid ='';
    for ($a=0; $a<=strlen($value); $a++) {
        switch (substr($value,$a,1)) {
            case '"': $valid .='&#34;'; break;
            case '<': $valid .='&#60;'; break;
            case '>': $valid .='&#62;'; break;
            case '&': $valid .='&#38;'; break;
            case '#': $valid .='&#35;'; break;
            case "'": $valid .='&#39;'; break;
            default: $valid .= substr($value,$a,1);
            }
        }
    return ($valid);
    }

function also($contentfile) {
    global $cf, $c, $sl, $sn, $su, $h, $adm, $s;
 
    if ($su=='') $temp = $h[0];
    else $temp = $h[$s];
    if (substr_count($temp,$cf['uri']['seperator'])>0) {
        for ($i = strlen($temp); $i>=0; $i--){
            if (substr($temp, $i, 1)==$cf['uri']['seperator']) break;
            }
        $current = substr($temp, $i+1, strlen($temp)-$i);
        }
    else $current = $temp;
    $subcontent = also_readfile($contentfile);
    if (!$adm) {if (substr($subcontent, 0, 18)=='Cannot open file (') return '';}
    $also = also_readcontents($subcontent);
    $also['name']=$contentfile;
    
    if ($adm) {
        $admin= isset($_POST['admin']) ? $_POST['admin'] : $_GET['admin'];
        $action= isset($_POST['action']) ? $_POST['action'] : $_GET['action'];
        if ($action==$contentfile & $admin=='also_savecontent') {
            if (substr($subcontent, 0, 18)!='Cannot open file (') {
                $count=$also['last'];
                $selected = -1;
                for ($i = 0; $i<=$count; $i++){ 
                    if (strtolower($current)==strtolower($also[$i]['h'])) {$selected=$i; break;}
                    }
                if ($selected!=-1) {$also[$selected]['content'] = stripslashes($_POST['subcontent-'.$contentfile]);}
                else {
                    $also[$count+1]['h'] = $current;
                    $also[$count+1]['content'] = stripslashes($_POST['subcontent-'.$contentfile]);
                    $also['last']++;
                    }
                }
            else {
                $also[0]['h'] = $current;
                $also[0]['content'] = stripslashes($_POST['subcontent-'.$contentfile]);
                $also['last']=1;
                }
            echo also_savecontents($also);
            header ('Location:'.$sn.'?'.$su);
            }
        }
    $currentcontent = '';
    for ($i = 0; $i<=count($h); $i++){ 
        if (strtolower($current)==strtolower($also[$i]['h'])) {$currentcontent = $also[$i]['content']; break;};
        }
    if (!$adm) {
        $t = str_replace('#', '=', $currentcontent).chr(10);
        }
    else {
        $t .= chr(10).'<P><strong>also:</strong> subcontent to show when in this page:</P>'.chr(10);
        $t .= '<FORM action="'.$sn.'?'.$su.'&amp;admin=also_savecontent&amp;action='.$contentfile.'" method="post"><TEXTAREA name="subcontent-'.$contentfile.'" rows="5" cols="15">'.also_vhtml($currentcontent).'</TEXTAREA>'.chr(10);
        $t .= '<INPUT type="submit" name="submit" value="save"></FORM>'.chr(10);
        }
    return $t;
    }


?>